var Cc = Components.classes;
var Ci = Components.interfaces;
var ROOT_PATH = "/home/paulr/Dev/mozilla";
var gRoot;
var gIdx = [];


var aserv = Cc["@mozilla.org/atom-service;1"].getService(Ci.nsIAtomService);


function log(str) {
  dump("+++ " + str + "\n");
}

function toggleDebug(checked) {
  var tc = document.getElementById("mtreechildren");
  if (checked)
    tc.setAttribute("debug", "true");
  else
    tc.removeAttribute("debug");

  var mtree = document.getElementById("mtree");
}

function getDescription(aFile, idx) {
  switch (idx) {
    case 0:
      return "Path: ";
    break;
    case 1:
      return aFile.path.replace(ROOT_PATH, "") + " ";
    break;
    case 2:

      //if (!aFile.leafName.match(/\.js|\.xul$|\.css|\.cpp$|\.h|\.idl/i))
      //  return "";
      // File preview
    try {
      var istream = Cc["@mozilla.org/network/file-input-stream;1"]
        .createInstance(Ci.nsIFileInputStream);
      istream.init(aFile, 0x01, 0444, 0);
      istream.QueryInterface(Ci.nsILineInputStream);
      var line = {}, lines = "", hasmore;
      var limit = 10;
      do {
        hasmore = istream.readLine(line);
        lines += line.value; 
        limit--;
      } while(hasmore && limit > 0);

      istream.close();
      return lines;
    } catch(e) {
      return "";
    }



    break;
    default:
    break;
  }
}

function onStart() {
  var rootFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
  rootFile.initWithPath(ROOT_PATH);
  gRoot = new TreeNode(rootFile, null);
  treeView.updateRowCount();

  var mtree = document.getElementById("mtree");
  mtree.view = treeView;
}

function TreeNode(aFile, parent) {
  this.leafName = aFile.leafName;
  this.children = null;
  this.perm = "0x" + aFile.permissions.toString(8);
  this.size = "0 Ko";
  if (aFile.fileSize > 1024 * 1024) 
    this.size = Math.round(aFile.fileSize / (1024 * 1024)) + " Mb";
  else if (aFile.fileSize > 1024)
    this.size = Math.round(aFile.fileSize / 1024) + " Kb";
  else
    this.size = aFile.fileSize  + "  B";
  if (aFile.isDirectory())
    this.size = "";
  this.hasContent = aFile.isDirectory() && aFile.directoryEntries.hasMoreElements();
  this.isDirectory = aFile.isDirectory();
  this.isOpen = false;
  this.file = aFile;
  this.contentSize = 0;
  this.parent = parent;

  this.fillChildren = function () {
    if (this.isDirectory) {
      var dirEntries = this.file.directoryEntries;
      var i = 0;
      while (dirEntries.hasMoreElements()) {
        i++;
        var entry = dirEntries.getNext();
        entry.QueryInterface(Ci.nsILocalFile);
        var child = new TreeNode(entry, this);
        if (!this.children)
          this.children = new Array();
        this.children.push(child);
      }
    }
  };
}

var treeView = {
  _rowCount: 0,
  updateRowCount: function() {
    var idx = 0;
    gIdx = new Array();
    function subCount(treeNode) {
      treeNode.idx = idx;
      gIdx[idx] = treeNode;
      idx++;
      treeNode.contentSize = 0;
      if (!treeNode.hasContent)
        return 1;
      if (!treeNode.isOpen)
        return 1;
      var count = 1;
      for each(var subNode in treeNode.children)
        count += subCount(subNode);
      treeNode.contentSize = count - 1;
      return count;
    }
    this._rowCount = subCount(gRoot);
  },



  // nsISupports
  QueryInterface: function(aIID) {
    if (aIID.equals(Ci.nsITreeView) ||
        aIID.equals(Ci.nsITreeView2) ||
        aIID.equals(Ci.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFAC
  },
  // nsITreeView2
  getItemText: function(row, idxItem) {
    return getDescription(gIdx[row].file, idxItem);
  },
  getItemCount: function(idx) {
    return 3;
  },
  getItemProperties: function(row, idxItem, properties) {
    if (idxItem == 1)
      properties.AppendElement(aserv.getAtom("path"));
    else if (idxItem == 2)
      properties.AppendElement(aserv.getAtom("preview"));

  },
  isMultiline: function() {
    return true;
  },


  // nsITreeView
  treeBox: null,
  selection: null,

  get rowCount()                     { return this._rowCount },
  setTree: function(treeBox)         { this.treeBox = treeBox; },
  getCellText: function(idx, column) {
    var node = gIdx[idx];
    if (column.id == "size")
      return node.size;
    if (column.id == "filename")
      return node.leafName;
    if (column.id == "permission")
      return node.perm;
  },
  isContainer: function(idx)         { return gIdx[idx].isDirectory;},
  isContainerOpen: function(idx)     { return gIdx[idx].isOpen;},
  isContainerEmpty: function(idx)    { return !gIdx[idx].hasContent;},
  isSeparator: function(idx)         { return false; },
  isSorted: function()               { return false; },
  isEditable: function(idx, column)  { return false; },

  getParentIndex: function(idx) {
    if (idx == 0)
      return -1;
    gIdx[idx].parent.idx;
  },
  getLevel: function(idx) {
    var node = gIdx[idx];
    var level = 0;
    while (node.parent != null) {
      node = node.parent;
      level++;
    }
    return level;
  },
  hasNextSibling: function(idx, after) {
    var node = gIdx[idx];
    var parent = node.parent;
    var res = parent[parent.children.length - 1].idx != idx;
    return res;
  },
  toggleOpenState: function(idx) {
    var node = gIdx[idx];
    node.isOpen = !node.isOpen;
    if (node.isOpen) {
      node.fillChildren();
    } else {
      node.children = null;
    }
    var lastRowCount = this.rowCount;
    this.updateRowCount();
    this.treeBox.rowCountChanged(idx + 1, this.rowCount - lastRowCount);
  },

  getImageSrc: function(idx, column) {},
  getProgressMode : function(idx,column) {},
  getCellValue: function(idx, column) {},
  cycleHeader: function(col, elem) {},
  selectionChanged: function() {},
  cycleCell: function(idx, column) {},
  performAction: function(action) {},
  performActionOnCell: function(action, index, column) {},
  getRowProperties: function(idx, prop) { },
  getCellProperties: function(idx, column, prop) {
    if (gIdx[idx].isDirectory)
      prop.AppendElement(aserv.getAtom("directory"));
  },
  getColumnProperties: function(column, element, prop) {},
};

window.addEventListener("load", onStart, true);
